import { Injectable } from '@nestjs/common';
import { InjectRepository } from '@nestjs/typeorm';
import { MapDrawingEntity } from 'src/game/coordinate.entity';
import { Repository } from 'typeorm';
import { MapDrawingDTO, DrawMapDTO } from './mapdrawing.dto';
import { Game_PersonEntity, GameEntity } from '../game/game.entity';
import { GameDTO, FactionDTO } from 'src/game/game.dto';
import { FactionEntity } from 'src/game/faction.entity';

@Injectable()
export class DrawService {
  constructor(
    @InjectRepository(MapDrawingEntity)
    private mapDrawingRepository: Repository<MapDrawingEntity>,
    @InjectRepository(FactionEntity)
    private factionRepository: Repository<FactionEntity>,
    @InjectRepository(Game_PersonEntity)
    private game_personRepository: Repository<Game_PersonEntity>,
  ) {}

  async draw(gameId, data: MapDrawingEntity) {
    data['gameId'] = gameId;
    const drawing = await this.mapDrawingRepository.create(data);

    if (data.mapDrawingId == null || data.mapDrawingId == '') {
      // luo uuden instanssin.
      return this.mapDrawingRepository.insert(drawing)[0];
    } else {
      //päivittää mapDrawingin
      return await this.mapDrawingRepository.save(drawing);
    }
  }

  // draw map based on game and
  async drawMap(id, data: MapDrawingEntity) {
    data['gameId'] = id;
    data['drawingIsActive'] = true;
    // get faction
    const mapDrawings = await this.mapDrawingRepository.create(data);

    // return mapdrawings with given faction and gameid
    return await this.mapDrawingRepository.find(mapDrawings);
  }

  // async trackLocation() {
  //   return 'location';
  // }
}
